#version 150
#include "base.h"
#include "../../mod_assets/negative_light.h"

in vec3 positionVarying;	// unused
in vec3 normalVarying;		// unused
in vec2 texcoordVarying;

out vec4 fragColor;

uniform sampler2D g_diffuseMap;
uniform sampler2D g_specularMap;
uniform sampler2D g_emissiveMap;
uniform sampler2D g_lightBuffer;
// emissive color is repurposed as the light color required for pixels to show
uniform vec3 g_emissiveColor; 
uniform vec2 g_invScreenSize;
uniform float g_time;
uniform float g_alphaBias;

void main()
{
	vec4 diffuseColor = texture(g_diffuseMap, texcoordVarying);
	
	// alpha testing
	diffuseColor.w = ceil(diffuseColor.w-0.5+g_alphaBias);
	
	vec4 light = texture(g_lightBuffer, gl_FragCoord.xy * g_invScreenSize);
	vec3 diffuseLight = light.xyz;
	
	// this formula was determined experimentally as giving good results
	// in the specific lighting conditions this shader is used in.
	// there's no principle behind it and it probably sucks at anything else.
	vec3 checkLight = round(length(diffuseLight) > 0.01 ? normalize(diffuseLight)*12.0 : diffuseLight);

	if (sign(g_emissiveColor) == sign(checkLight)) {
		fragColor = vec4(resolveLight(diffuseLight, g_time) * diffuseColor.xyz, diffuseColor.w);
	} else {
		fragColor = vec4(0.0,0.0,0.0,0.0);
	}
}
