#version 150
#include "base.h"

in vec3 positionVarying;	// unused
in vec3 normalVarying;		// unused
in vec2 texcoordVarying;

out vec4 fragColor;

uniform sampler2D g_diffuseMap;
uniform sampler2D g_lightBuffer;
uniform vec3 g_emissiveColor;
uniform vec2 g_invScreenSize;
uniform float g_time;

void main()
{
	vec4 diffuseColor = texture(g_diffuseMap, texcoordVarying);
	
	// alpha testing
	diffuseColor.w = ceil(diffuseColor.w-0.5);
	
	vec4 light = texture(g_lightBuffer, gl_FragCoord.xy * g_invScreenSize);
	vec3 diffuseLight = light.xyz;

	if (length(diffuseLight) < 0.01) {
		fragColor = vec4(1.0,1.0,1.0,diffuseColor.w);
	} else {
		fragColor = vec4(0.0,0.0,0.0,0.0);
	}
}
