defineTile{name = "",editorIcon=192,color={0,0,0,255},builder="dungeon"}

-- unfortunately we need some standard races and classes, otherwise the game
-- crashes before we can make it to our sandbox-escaping spawn call
import "assets/scripts/races.lua"
import "assets/scripts/char_classes.lua"
import "assets/scripts/skills.lua"
import "assets/scripts/traits.lua"

defineObject{name = "",
	placement = "floor",
	components = {
		-- These two components are needed for the sandbox escape
		{
			class = "MonsterGroup",
			name = "m",
			count = function(self)
				return {self}
			end,
		},
		{
			class = "Socket",
			name = "s",
		},
		-- This one is used for fast _G access
		-- FILESIZE: I can probably simplify this
		{
			class = "Party",
			name = "p",
		},
	},
}

-- necessary for loading savegames to work
-- we don't let the player use grimrock's regular save system, but interacting
-- with saves is necessary to automatically restart the mod after changing rendering quality
defineObject{
	name = "party",
	components = {
		{
			class = "Party",
		},
	},
	placement = "floor",
}

-- don't let players waste time creating characters; start the game immediately
-- if they go to the character creation screen
local started
defineTrait{
	name = "human",
	uiName = "",
	icon = 1,
	description = "",
	onRecomputeStats = function(champion, level)
		if Dungeon.getMaxLevels() == 0 and not started then
			started = true
			local escaper = spawn("")
			local champion = escaper.s.count(escaper.m)[1].go.p.champions[1]
			champion:setCondition("level_up",1)
			vec.__concat = function() return "_G" end
			local capitalize = string.capitalize
			string.capitalize = function() return vec() end
			local _G = champion.conditions.level_up.__class.getConditionClass("")
			string.capitalize = capitalize
			vec.__concat = nil
			champion:removeCondition("level_up")
			escaper:destroy()
			_G.CharacterGeneration.startGame()
		end
	end,	
}
