#version 150
#include "base.h"
#include "../../mod_assets/negative_light.h"

in vec3 positionVarying;	// unused
in vec3 normalVarying;		// unused
in vec2 texcoordVarying;

out vec4 fragColor;

uniform vec3 g_emissiveColor;
uniform float g_streakCount;
uniform float g_streakWidth;
uniform float g_time;
uniform float g_speed;
uniform float g_coreRadius;

uniform vec2 g_invScreenSize;

// TODO optimize this garbagbe
void main()
{
	vec2 texcoordCentered = texcoordVarying - vec2(0.5, 0.5);

	float angle = mod(atan(texcoordCentered.y, texcoordCentered.x)+g_time*g_speed, M_PI*2.0/g_streakCount);
	
	float distanceFromCenter = min(length(texcoordCentered)*2.0, 1.0);
	
	float distanceFalloff = pow(1.0-distanceFromCenter,4.0);
	
	float on = abs(angle - M_PI/g_streakCount) < (g_streakWidth*distanceFalloff) ? 1.0 : 0.0;
	
	fragColor = vec4(resolveLight(g_emissiveColor, g_time)*on, 1.0);
}
