#version 150
#include "base.h"
in vec4 position;
in vec2 texcoord;

out vec3 positionVarying;
out vec2 texcoordVarying;

uniform mat4 g_modelView;
uniform mat4 g_proj;

uniform vec2 g_invScreenSize;

uniform float g_sparkleSize;

void main()
{	
	vec4 pos = g_modelView * position;

	// massive particle-style depth bias
	pos.xyz -= normalize(pos.xyz) * 0.02;
	
	// expand vertices in view space
	pos.xy = pos.xy + normalize(texcoord) * g_sparkleSize;
	
	pos = g_proj * pos;
	
	gl_Position = pos;
	positionVarying = pos.xyz;
	texcoordVarying = unpackTexcoord(texcoord);
}
