#version 150
in vec4 position;
in vec2 texcoord;
in vec4 color;

out vec3 positionVarying;
out vec4 colorVarying;
out float pointID;

uniform mat4 g_modelView;
uniform mat4 g_proj;

uniform vec2 g_invScreenSize;

void main()
{	
	vec4 pos = g_modelView * position;
	
	pos = g_proj * pos;
	
	// expand vertices in clip space
	// multiplier of 1.5 causes stars to occasionally draw as multiple
	// pixels, but anything less causes them to flicker too much
	// let's just hope there isn't too much hardware dependence here...
	pos.xy = pos.xy + normalize(texcoord)*g_invScreenSize*pos.w*1.5;
	gl_Position = pos;
	positionVarying = pos.xyz;
	pointID = gl_VertexID;
	colorVarying = color * (1.0/255.0);
}
