// 1/255
#define INV_COLOR_MAX 0.003921568627

in vec4 position;
in vec3 normal; // 3 random integers 0-255, used to calculate initial velocity
in vec4 tangent;
in vec4 color; // 4 random integers 0-255
in vec2 texcoord;

out vec3 positionVarying;
out vec4 colorVarying;

uniform mat4 g_modelView;
uniform mat4 g_proj;

uniform vec3 g_particleBoxMin;
uniform vec3 g_particleBoxMax;
uniform vec3 g_particleLifetime; // min, max, cycle duration
uniform vec4 g_particleColor;
uniform vec3 g_particleGravity;
uniform vec4 g_particleMovementParams; // velocity min, velocity max, spray angle min, spray angle max
uniform float g_particleAirResistance;
uniform vec2 g_particleRotationParams; // rotationSpeed, randomInitialRotation ? 0 : TAU
uniform vec3 g_particleFadeParams; // 1/fadeIn, 1/fadeOut, fadeOut
uniform float g_particleDepthBias;

uniform float g_particleTime;
uniform float g_timeSinceStop;

uniform vec2 g_invScreenSize;

// normally you'd just use the texcoords for this, that's fewer operations, but
// there are a lot of things I want to appear random per-particle and very few
// things I can conveniently pass to the shader per-particle (basically only
// mesh properties that I can assign from Lua without going into ffi horrors).
vec2 particleVertexExpansionDirection() {
	return vec2(gl_VertexID & 1, ((gl_VertexID+2) & 2) >> 1);
}
