#version 150
#include "base.h"
#include "../../mod_assets/negative_light.h"

in vec3 positionVarying;	// unused
in vec3 normalVarying;		// unused
in vec2 texcoordVarying;

out vec4 fragColor;

uniform sampler2D g_diffuseMap;
uniform sampler2D g_specularMap;
uniform sampler2D g_emissiveMap;
uniform sampler2D g_lightBuffer;
// emissive color is repurposed as the light color required for pixels to show
uniform vec3 g_emissiveColor; 
uniform vec2 g_invScreenSize;
uniform vec3 lightThreshold = vec3(0.5,0.5,0.5);
uniform float g_time;

// TODO optimize a lot
void main()
{
	vec4 diffuseColor = texture(g_diffuseMap, texcoordVarying);
	
	//if (diffuseColor.w < 0.5) {
	//	diffuseColor.w = 0.0;
	//} else {
	//	diffuseColor.w = 1.0;
	//}
	
#ifdef ALPHA_TEST
	if(diffuseColor.w < 0.5)
		discard;
#endif
	//vec3 specularColor = texture(g_specularMap, texcoordVarying).xyz;
	//vec3 emissiveColor = texture(g_emissiveMap, texcoordVarying).xyz;
	
	vec4 light = texture(g_lightBuffer, gl_FragCoord.xy * g_invScreenSize);
	vec3 diffuseLight = light.xyz;
	//vec3 specularLight = chromacity(diffuseLight) * light.w;
	
	//fragColor = vec4(g_emissiveColor, 1);

	
	
	// dumb special case for black text
	if (length(g_emissiveColor) < 0.01) {
		if (all(lessThan(diffuseLight,lightThreshold))) {
			fragColor = vec4(1.0,1.0,1.0,diffuseColor.w);
		} else {
			discard;
		}
	} else if (any(greaterThan(diffuseLight,lightThreshold))) {
		vec3 lightColorDifference = normalize(g_emissiveColor)-normalize(diffuseLight);
		if (all(lessThan(lightColorDifference,vec3(0.1,0.1,0.1))) && all(greaterThan(lightColorDifference,vec3(-0.1,-0.1,-0.1)))) {
			fragColor = vec4(resolveLight(diffuseLight * diffuseColor.xyz, g_time), diffuseColor.w);
		} else {
			discard;
		}
	} else {
		discard;
	}
	
	
}
