-- just normal playSound2D() with volume and pitch parameters added
function SoundSystem:playSound2D(name, volume, pitch)
	local sample = dungeon.samples[name]
	if not sample then console:warn("no such sample: "..name); return end

	local sound = SoundSource.create(self.globalSounds)
	sound:setVolume(sample.volume*(volume or 1))
	sound:setMute(self.mute)
	sound:setLoop(sample.loop)
	if pitch then sound:setPitch(pitch) end
	sound:play(sample.clips[math.random(#sample.clips)], false)

	self.sounds[#self.sounds+1] = {
		sound = sound,
		name = name,
		autoDestroy = true
	}
end
