function vec.angleBetween(a,b)
	local dot = a[1]*b[1]+a[2]*b[2]+a[3]*b[3]
	local cross = vec.cross(a,b)
	return math.atan2(vec.length3(cross), dot)
end

function vec.normalizeInPlace3(v)
	local x,y,z = v[1], v[2], v[3]
	local len = (x*x+y*y+z*z)^0.5
	v[1] = x/len
	v[2] = y/len
	v[3] = z/len
end

function vec.mulInPlace(v,s)
	v[1] = v[1]*s
	v[2] = v[2]*s
	v[3] = v[3]*s
	v[4] = v[4]*s
end

function vec.addInPlaceV(v,v2)
	v[1] = v[1]+v2[1]
	v[2] = v[2]+v2[2]
	v[3] = v[3]+v2[3]
	v[4] = v[4]+v2[4]
end
